<template>
  <v-app>
  <v-container>
    <h2 class="my-3">Gestion des catégories</h2>
    <h3>La liste des catégories disponible</h3>
    <br>
    <table class="center" border="1"> <!-- Récupération des catégories ajoutés dans la base -->
      <tr>
        <th>UUID</th>
        <th>Nom</th>
        <th>Traduction</th>
        <th>Description</th>
      </tr>
      <tr v-for="cat in result" :key="cat.uuidcategorie">
        <td>{{ cat.uuidcategorie }}</td>
        <td>{{ cat.libellecategorie }}</td>
        <td>{{ cat.libellelangue }}</td>
        <td>{{ cat.descriptioncategorie }}</td>
      </tr>
    </table>
    <br>
    <h3>Ajouter/Modifier une catégorie</h3>
    <v-list>
      <v-list-tile v-for="(langue, index) in langues" :key="langue.isolangue" :index="index">
        <v-list-tile v-text="langue.libellelangue" v-model="isolangue[index]"> 
        </v-list-tile>
        <v-list-tile>
            <v-text-field v-model="libellecategorie[index]" label="Libellé de la catégorie"></v-text-field>
        </v-list-tile>
      </v-list-tile> 
    </v-list>
    <v-btn outline color="light-green darken-2" v-on:click="Ajout()">Ajouter</v-btn>
    <v-btn outline color="amber darken-2">Modifier</v-btn>
    <br>
    <h3>Ajouter une catégorie</h3>
    <v-layout column wrap> <!-- Ajouter une catégorie -->
      <v-layout row wrap>
        <v-flex md4>
          <v-text-field name="input-1" label="Libellé de la catégorie"></v-text-field>
        </v-flex>
        <v-flex offset-md1 md4>
          <v-text-field name="input-1" v-model="descriptioncategorie" label="Description de la catégorie"></v-text-field>
        </v-flex>
      </v-layout>
      <v-layout row>
        <v-flex md4>
          <v-select label="Choisir une langue" v-model="choixlangue" v-bind:items="langues" item-text="libellelangue" item-value="isolangue">
          </v-select>
        </v-flex>
        <v-flex offset-md1 md1>
          <v-btn outline color="light-green darken-1" v-on:click="addCategorie()">Ajouter</v-btn>
        </v-flex>
      </v-layout>
    </v-layout>
    <br>
    <h3>Modifier une catégorie</h3> <!-- Modifier une catégorie -->
    <v-layout row wrap>
      <v-flex md4>
        <v-select label="Modifier une catégorie" v-model="modifiercategorie" v-bind:items="result" item-text="libellecategorie" item-value="uuidcategorie">
        </v-select>
      </v-flex>
      <v-flex md4 offset-md1>
        <v-select label="Langue" v-model="modiflangue" v-bind:items="langues" item-text="libellelangue" item-value="isolangue">
        </v-select>
      </v-flex>
      <v-btn color="primary" outline v-on:click="idCategorie()">Choisir</v-btn>
    </v-layout>
    <v-layout row wrap>
      <v-layout column wrap>
        <v-flex md6>
        <div v-for="choix in choixcat" :key="choix.uuidcategorie">
          <div v-if="choixcat.length">
            <br>
            <p>Nom :<input type="text" v-model="modifierlibellecategorie" placeholder="Nom"> {{choix.libellecategorie}} </p>
            <p>Description :<input type="text" v-model="modifierdescriptioncategorie" placeholder="Description"> {{choix.descriptioncategorie}} </p>
            <v-btn color="warning" v-on:click="putCategorie()">Appliquer</v-btn>
          </div>
          <div v-else>
            <p>Cette traduction n'existe pas !</p>
            <v-flex md6>
              <p>Nom :<input type="text" v-model="traductionlibellecategorie" placeholder="Nom"> </p>
              <p>Description :<input type="text" v-model="traductiondescriptioncategorie" placeholder="Description"></p>
              <p>Langue : <select name="langue" v-model="traductionlangue">
                  <option v-for="langue in langues" v-bind:value="langue.isolangue" :key="langue.isolangue">{{ langue.libellelangue }}</option>
                </select>
              </p>
              {{ modiflangue }}
              <v-btn outline color="light-green darken-1" v-on:click="AjouterTraduction()">Ajouter une traduction</v-btn>
            </v-flex>
          </div>
        </div>
        </v-flex>
      </v-layout>
    </v-layout>
    <br>
    <h3>Supprimer une catégorie</h3> <!-- Supprimer une catégorie -->
    <v-layout row wrap>
      <v-flex md4>
        <v-select label="Supprimer une catégorie" v-model="supprimeCategorie" v-bind:items="result" item-text="libellecategorie" item-value="uuidcategorie">
        </v-select>
      </v-flex>
      <v-flex offset-md1>
        <v-btn outline color="error" @click.native.stop="dialog = true">Supprimer</v-btn>
      </v-flex>
    </v-layout>
    <v-dialog v-model="dialog" max-width="350">
      <v-card>
        <v-card-title class="headline">Confirmation de suppression</v-card-title>
        <v-card-text>Etes-vous sûr de vouloir supprimer la catégorie ?</v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn outline color="green darken-1" flat="flat" @click.native="dialog = false">Annuler</v-btn>
          <v-btn outline color="error" flat="flat" v-on:click="deleteCategorie()" @click.native="dialog = false">Supprimer</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
  </v-app>
</template>

<script>
export default {
  data () {
    return {
      langues: [],
      result: [],
      choixcat: [],
      libellecategorie: [],
      descriptioncategorie: '',
      supprimeCategorie: '',
      modifiercategorie: '',
      modifierlibellecategorie: '',
      modifierdescriptioncategorie: '',
      choixlangue: '',
      modifierlangue: '',
      traductionlibellecategorie: '',
      traductiondescriptioncategorie: '',
      traductionlangue: '',
      modiflangue: '',
      isolangue: [],
      dialog: false
    }
  },
  mounted () {
    this.getCategories()
  },
  methods: {
    getCategories: function () {
      this.$http.get('http://localhost:3000/categorie')
      .then(response => {
        this.result = response.data
      })
      this.$http.get('http://localhost:3000/langue')
      .then(response => {
        this.langues = response.data
      })
    },
    Ajout: function () {
      console.log('POST : ', this.isolangue, this.libellecategorie)
      const ajout = {
        nom: this.libellecategorie,
        description: this.descriptioncategorie,
        langue: this.choixlangue
      }
      this.$http.post('http://localhost:3000/categorie', ajout)
        .then(response => {
          console.log('POST : ', response)
          this.getCategories()
        })
    },
    addCategorie: function () {
      const ajoutcategorie = {
        nom: this.libellecategorie,
        description: this.descriptioncategorie,
        langue: this.choixlangue
      }
      if (this.libellecategorie === '') {
        alert('Veillez saisir avant d\'ajouter une catégorie')
      } else {
        this.$http.post('http://localhost:3000/categorie', ajoutcategorie)
        .then(response => {
          console.log('POST : ', response)
          this.getCategories()
        })
      }
    },
    idCategorie: function () {
      this.$http.get('http://localhost:3000/categorie/' + this.modifiercategorie, {params: {langue: this.modiflangue}})
      .then(response => {
        this.choixcat = response.data
        console.log('GET', this.choixcat)
        console.log('GEt ID', response)
      })
    },
    putCategorie: function () {
      const modifcategorie = {
        nom: this.modifierlibellecategorie,
        description: this.modifierdescriptioncategorie,
        langue: this.modifierlangue
      }
      this.$http.put('http://localhost:3000/categorie/' + this.modifiercategorie, modifcategorie)
      .then(response => {
        console.log('PUT CATEGORIE ', response)
        this.getCategories()
      })
    },
    deleteCategorie: function () {
      if (this.supprimeCategorie === '') {
        alert('Veillez choisir une catégorie avant de supprimer')
      } else {
        this.$http.delete('http://localhost:3000/categorie/' + this.supprimeCategorie)
        .then(response => {
          console.log('DELETE :', response)
          this.getCategories()
        })
        .catch(response => {
          console.log('ERROR : ', response.status)
        })
      }
    }
  }
}
</script>